#ifndef TEXMACS_WINDOWS_SYSTEM_HPP
#define TEXMACS_WINDOWS_SYSTEM_HPP

#include "string.hpp"
#include "array.hpp"
#include <string>
#include "string_encoding.hpp"

typedef struct _stat64 struct_stat;

struct texmacs_dir_t;

typedef struct texmacs_dir_t* TEXMACS_DIR;

typedef struct texmacs_dirent {
    bool           is_valid;     /* entry is valid */
    string         d_name;      /* nom du fichier */
} texmacs_dirent;

void texmacs_init_guile_hooks();

FILE* texmacs_fopen(string filename, string mode, bool lock = true);

void texmacs_fclose(FILE *&file, bool unlock = true);

TEXMACS_DIR texmacs_opendir(string dirname);

void texmacs_closedir(TEXMACS_DIR &dir);

texmacs_dirent texmacs_readdir(TEXMACS_DIR dirp);

bool texmacs_stat(string filename, struct_stat* buf);

string texmacs_getenv(string variable_name);

bool texmacs_setenv(string variable_name, string new_value);

bool texmacs_putenv(string variable);

bool texmacs_mkdir(string dirname, int mode);

bool texmacs_rmdir(string dirname);

bool texmacs_rename(string oldname, string newname);

bool texmacs_chmod(string filename, int mode);

bool texmacs_remove(string filename);

void texmacs_attach_console();

void texmacs_initialize_displayname();

intptr_t texmacs_spawnvp(int mode, string name, ::array<::string> args);

#endif